#!/usr/bin/perl

##
## GeekTools WHOIS Proxy ACL management CGI.
## Ugly, but it works (at least for me).  Got any suggestions for improvement?
## Improve it and send us a diff.
##
## You'll probably want to change the values in $AdminID and $AdminPass 
## unless you want strangers to change your ACL for you.
##

use CGI qw(:standard);
use AnyDBM_File;

###
### File locations and other constants.
###

$AccessList  = "/usr/local/geektools/accesslist";
$URLBase     = "/cgi-bin/acladmin.cgi";

$AdminID     = "changeme";
$AdminPass   = "password";

###
### From CGI variables or cookies
###

$Action  = param("action");
$UserID  = param("userid");
$Passwd  = param("pass");
$NewP1   = param("pass1");
$NewP2   = param("pass2");
$Nuke    = param("nukeid");
$IPAddr  = param("ipaddr");
$IPLast  = param("iplast");
$HitMax  = param("hitmax");

if ($Action eq "") {
   &ShowLogin();
} 

if ($Action eq "logout") { &LogOut(); }
if ($Action eq "mainmenu") { print header(); &ShowMenu(); }

if ($Action eq "newaddr") { print header(); &AddIP(); }
if ($Action eq "addip") { print header(); &AddToDB(); }

if ($Action eq "deladdr") { print header(); &DeleteAddr(); }
if ($Action eq "delip") { print header(); &DelIP(); };

if ($Action eq "viewlist") { &ViewList(); }

if ($Action eq "login") {
   if ($Passwd eq $AdminPass && $UserID eq $AdminID) {
      $authcookie = cookie( -NAME    => "gtadmin",
                           -VALUE   => "$UserID",
                           -EXPIRES => "+30m");   
      print header(-COOKIE => $authcookie);
      print start_html(-title => "Login Accepted",
                      -BGCOLOR=>'#ffffff');
      print "Login ok, <a href=\"$URLBase?action=mainmenu\">";
      print "click here</a> to continue.";
      print end_html;
   } else {
     &NoAccess(); 
   }
}

sub NoAccess
{
  print header; 
  print start_html(-title => "I don't think so!",
                   -BGCOLOR => '#ff000000');
  print h1("<center>Access Denied!</center>");
  print "<center>Er, you seem to have entered the wrong stuff.</center>";
  print end_html;
  exit 0;
} 
   

sub ShowLogin
{
   print header();
   print start_html(-title  => 'GeekTools WHOIS Proxy Access Control',
                    -BGCOLOR => '#ffffff');
   print '<font face="Arial, Helvetica" size="4">';
   print '<center>GeekTools WHOIS Proxy: Log In</center>';
   print '</font>';
   print '<font face="Arial, Helvetica" size="2">';
   print "<form action=\"$URLBase\" method=\"POST\">";
   print '<center>';
   print 'Login: ';
   print '<input type="text" name="userid"> ';
   print 'Password: <input type="password" name="pass"> ';
   print '<input type="hidden" name="action" value="login"><br>';
   print '<input type="submit" value="Log In">';
   print '</center>';
   print '</form>';
   print end_html;
}

sub ShowMenu
{
  print start_html(-title => "GeekTools WHOIS Proxy Access Control",
                   -BGCOLOR => '#ffffff');
  $AuthID = cookie("gtadmin");
  if ($AuthID eq "") { &NoAccess(); }
  print '<font face="Arial, Helvetica" size="4">';
  print '<center>GeekTools WHOIS Proxy Access Control<br>';
  print '<font face="Arial, Helvetica" size="2">';
  print "Logged in: $AuthID</center><p>";
  print '</center>';
  print '<center><table id="1" border="0">';
  print "<td><a href=\"$URLBase?action=viewlist\">View Access Lists</a>";
  print "</td><td>Show the contents of the whois proxy access ";
  print "lists.</td><tr>";
  print "<td><a href=\"$URLBase?action=newaddr\">Add New IP Address/Range</a>";
  print "</td><td>Add a new IP address or range to the whois proxy access ";
  print "lists.</td><tr>";
  print "<td><a href=\"$URLBase?action=deladdr\">Delete IP Address/Range</a>"; 
  print "</td><td>Remove IP addresses or ranges from the whois proxy ";
  print "access lists.</td><tr>";
  print "<td></td><td></td><tr>";
  print "<td><a href=\"$URLBase?action=logout\">Log Out</a>"; 
  print "</td><td>Log out immediately.</td><tr> ";
  print '</table>';
  print end_html;
  exit 0;
   
}

sub LogOut
{
   $authcookie = cookie( -NAME    => "gtadmin",
                         -VALUE   => "null",
                         -EXPIRES => "now");
   print header(-COOKIE => $authcookie);
   print start_html(-title=>"Logged Out", -BGCOLOR=>'#ffffff');
   print '<font face="Arial, Helvetica" size="3"><center>';
   print 'Logout successful.  You must log in again if you want to make ';
   print 'more changes.<p>';
   print "<a href=\"$URLBase?action=\">Log In</a>";
   print '</center>';
   print end_html;
}

sub AddIP
{
  print start_html(-title => "GeekTools WHOIS Proxy: Add IP",
                   -BGCOLOR => '#ffffff');
  $AuthID = cookie("gtadmin");
  if ($AuthID eq "") { &NoAccess(); }
  print '<font face="Arial, Helvetica" size="4">';
  print '<center>Add An IP Address Or Range<br>';
  print '<font face="Arial, Helvetica" size="2">';
  print "Logged in: $AuthID</center><p>";
  print '</center>';
  print "<form action=\"$URLBase\" method=\"POST\">";
  print '<center>';
  print '<p>';
  print 'Enter a partial address, a complete address, or a complete address ';
  print 'and an optional ending octet.<br>For example:  204.68, 204.68.171, ';
  print '204.68.171.2 or 204.68.171.2 with "5" as the last octet to cover ';
  print '204.68.171.2 to 204.68.171.5 inclusive.<p>';
  print 'Starting (or single) address: <input type="text" name="ipaddr"> ';
  print 'Last octet: <input type="text" name="iplast" size="3"><br>';
  print 'Hit limit per day: <select name="hitmax" size="1">';
  print '<option value="500">500</option>';
  print '<option value="1000">1000</option>';
  print '<option value="U">Unlimited</option>';
  print '<option value="L">Locked Out</option>';
  print '</select><br>';
  print '<input type="hidden" name="action" value="addip">';
  print '<input type="submit" value="Add It">';
  print '<input type="reset" value="Start Over"';
  print '</form><p>';
  print "<a href=\"$URLBase?action=mainmenu\">Main Menu</a>";
  print '</center>';
  print end_html;
}

sub AddToDB
{
  print start_html(-title => "GeekTools WHOIS Proxy: Add IP",
                   -BGCOLOR => '#ffffff');
 $AuthID = cookie("gtadmin");
  if ($AuthID eq "") { &NoAccess(); }
  print '<font face="Arial, Helvetica" size="4">';
  print '<center>Add An IP Address Or Range<br>';
  print '<font face="Arial, Helvetica" size="2">';
  print "Logged in: $AuthID</center><p>";

  if ($IPLast ne "") {
     ($Oct1,$Oct2,$Oct3,$Oct4) = split /\./, $IPAddr;
     print "Starting at $IPAddr, ending at $Oct1.$Oct2.$Oct3.$IPLast<br>";
     if ($IPLast < $Oct4) {
       print "Nice try.  I'm not going to count backwards for you.<br>";
     }
      
     #Add the ip's in the range - descending order for neatness ;)
     dbmopen(%accesslist,$AccessList,0644);
     print '<center><p>';
     while ($IPLast > $Oct4) {
           $InsertIP = $Oct1 . "." . $Oct2 . "." . $Oct3 . "." . $IPLast;
           $accesslist{"$InsertIP"} = $HitMax;
           print "Added $InsertIP for $HitMax hits per day.<br>";
           $IPLast--;
     }
     dbmclose(%accesslist);
  } 
  dbmopen(%accesslist,$AccessList,0644);
  $accesslist{"$IPAddr"} = $HitMax;
  dbmclose(%accesslist);
  print "Added $IPAddr for $HitMax hits per day.<p>";
  print "<a href=\"$URLBase?action=mainmenu\">Main Menu</a>";
  print '</center>';
  print end_html;
}

sub DeleteAddr
{
  print start_html(-title => "GeekTools WHOIS Proxy: Delete IP",
                   -BGCOLOR => '#ffffff');
  $AuthID = cookie("gtadmin");
  if ($AuthID eq "") { &NoAccess(); }
  print '<font face="Arial, Helvetica" size="4">';
  print '<center>Delete An IP Address Or Range<br>';
  
print '<font face="Arial, Helvetica" size="2">';
  print "Logged in: $AuthID</center><p>";
  print '</center>';
  print "<form action=\"$URLBase\" method=\"POST\">";
  print '<center>';
  print '<p>';
  print 'Enter the address or pattern to delete.  Current list entries are ';
  print 'show below for your reference.<p>';
  print '<input type="text" name="ipaddr">';
  print '<br>';
  print '<input type="hidden" name="action" value="delip">';
  print '<input type="submit" value="Nuke It">';
  print '<input type="reset" value="Start Over"';
  print '</form><p>';
  print "<a href=\"$URLBase?action=mainmenu\">Main Menu</a>";
  print '</center>';
  print '<p>';
  print 'Current entries in the access list (click to remove):<p>';
  print '<table id="0" border="2">';
  print '<td>Address</td><td>Hit Limit</td><tr>';
  dbmopen (%access,$AccessList, 0644) || die "Error: $!\n";
   while (($key, $value) = each(%access)) {
         print "<td><a href=\"$URLBase?action=delip\&ipaddr=$key\">";
         print "$key</a></td>";
         if ($value eq "L") { $value = "Locked Out"; }
         if ($value eq "U") { $value = "Unlimited"; }
         print "<td>$value</td><tr>";
   }
  dbmclose(%access);
  print '</table>';  
  print end_html;
}

sub DelIP
{
  print start_html(-title => "GeekTools WHOIS Proxy: Delete IP",
                   -BGCOLOR => '#ffffff');
  $AuthID = cookie("gtadmin");
  if ($AuthID eq "") { &NoAccess(); }
  print '<font face="Arial, Helvetica" size="4">';
  print '<center>Delete An IP Address Or Range<br>';
  print '<font face="Arial, Helvetica" size="2">';
  print "Logged in: $AuthID</center><p>";
  print '</center>';
  print '<p>';
  print '<center>';
  dbmopen(%accesslist, $AccessList, 0644);
  delete $accesslist{"$IPAddr"};
  dbmclose(%accesslist);
  print "Deleted $IPAddr from the access list.<p>";
  print "<a href=\"$URLBase?action=mainmenu\">Main Menu</a>";
  print '</center>';
  print end_html;

}

sub ViewList 
{
  print header;
  print start_html(-title => "GeekTools WHOIS Proxy: View ACL",
                   -BGCOLOR => '#ffffff');
  $AuthID = cookie("gtadmin");
  if ($AuthID eq "") { &NoAccess(); }
  print '<font face="Arial, Helvetica" size="4">';
  print '<center>ACL Contents<br>';
  print '<font face="Arial, Helvetica" size="2">';
  print "Logged in: $AuthID</center><p>";
  print '</center>';
  print '<p>';
  print '<center>';
  print '<table id="0" border="2">';
  print '<td>Address</td><td>Hit Limit</td><tr>';
  dbmopen (%access,$AccessList, 0644) || die "Error: $!\n";
   while (($key, $value) = each(%access)) {
         print "<td>$key</td>";
         if ($value eq "L") { $value = "Locked Out"; }
         if ($value eq "U") { $value = "Unlimited"; }
         print "<td>$value</td><tr>";
   }
  dbmclose(%access);
  print '</table>';
  print "<a href=\"$URLBase?action=mainmenu\">Main Menu</a>";
  print '</center>';

  print end_html;


}

